'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var QRious = _interopDefault(require('qrious'));

var LEVELS = ['L', 'M', 'Q', 'H'];
var index = {
    props: {
        value: {
            type: String,
            required: true,
        },
        background: String,
        backgroundAlpha: Number,
        foreground: String,
        foregroundAlpha: Number,
        level: {
            type: String,
            validator: function (level) { return LEVELS.includes(level); },
        },
        mime: String,
        padding: Number,
        size: Number,
    },
    data: function () {
        var qrious = new QRious(this.$props);
        return {
            qrious: qrious,
            dataUrl: qrious.toDataURL(this.mime),
        };
    },
    watch: {
        $props: {
            deep: true,
            handler: function () {
                this.qrious.set(this.$props);
                this.dataUrl = this.qrious.toDataURL(this.mime);
            },
        },
    },
    render: function () {
        return this.$createElement('img', {
            domProps: {
                src: this.dataUrl,
            },
            attrs: this.$attrs,
        });
    },
};

module.exports = index;
